//--------------------------------------------------------------------------//
// iq . 2007 . kindernoiser 4k intro demo by RGBA                           //
//--------------------------------------------------------------------------//

static const char fsh_julia3D[] = \

"uniform vec4 fpar[4];"

"float jinteresct(in vec3 rO, in vec3 rD, in vec4 c)"
"{"
    "float mz2,md2,dist,t;"
    "float res=1000.;"
    "vec4 z,nz;"

    "int nite = int(fpar[0].w);"

    "for(t=0.0;t<6.0;t+=dist)"
    "{"
        "vec3 p=rO+t*rD;"

        //"if(dot(p,p)>4.0) break;"  

        // calc distance
        "z=vec4(p,(c.y+c.x)*.3);"
        "md2=1.;"
        "mz2=dot(z,z);"

        "for(int i=0;i<nite;i++)"
        "{"
            // |dz|^2 -> 4*|dz|^2
            "md2*=4.*mz2;"
            // z -> z2 + c
            "nz.x=z.x*z.x-dot(z.yzw,z.yzw);"
            "nz.yzw=2.*z.x*z.yzw;"
            "z=nz+c;"

            "mz2=dot(z,z);"
            "if(mz2>4.)"
                "break;"
        "}"

        "dist=0.25*sqrt(mz2/md2)*log(mz2);"

        "if(dist<0.0005)"
        "{"
            "res=t;"
            "break;"
        "}"

    "}"

    "return res;"
"}"


"vec3 calcNormal(in vec3 p, in vec4 c)"
"{"
    "vec4 z,nz,ndz,dz[4];"

    "z=vec4(p,(c.y+c.x)*.3);"

    "dz[0]=vec4(1.,0.,0.,0.);"
    "dz[1]=vec4(0.,1.,0.,0.);"
    "dz[2]=vec4(0.,0.,1.,0.);"
  //"dz[3]=vec4(0.,0.,0.,1.);"

    "int nite=int(fpar[0].w);"
    "for(int i=0;i<nite;i++)"
    "{"
        "vec4 mz = vec4(z.x,-z.y,-z.z,-z.w);"

        // derivative
        "dz[0]=vec4(dot(mz,dz[0]),z.x*dz[0].yzw+dz[0].x*z.yzw);"
        "dz[1]=vec4(dot(mz,dz[1]),z.x*dz[1].yzw+dz[1].x*z.yzw);"
        "dz[2]=vec4(dot(mz,dz[2]),z.x*dz[2].yzw+dz[2].x*z.yzw);"
      //"dz[3]=vec4(dot(mz,dz[3]),z.x*dz[3].yzw+dz[3].x*z.yzw);"

        // z = z2 + c
        "nz.x=dot(z, mz);"
        "nz.yzw=2.*z.x*z.yzw;"
        "z=nz+c;"

        "if(dot(z,z)>4.)"
            "break;"
    "}"

    "return normalize(vec3(dot(z,dz[0]),"
                          "dot(z,dz[1]),"
                          "dot(z,dz[2])));"
"}"


"void main(void)"
"{"
    "float irlen = inversesqrt(dot(gl_TexCoord[0].xyz,gl_TexCoord[0].xyz));"
    "vec3 nwrd = gl_TexCoord[1].xyz*irlen;"
    "vec3 nerd = gl_TexCoord[0].xyz*irlen;"
    "vec3 nor = vec3(0.);"
    "vec3 wro = fpar[0].xyz;"
    "float t = jinteresct(wro,nwrd,fpar[2]);"
    "if(t<100.)"
    "{"
        "vec3 inter = wro + t*nwrd;"
        "nor = calcNormal(inter,fpar[2]);"
    "}"
    "gl_FragColor = vec4(t*nerd.z,nor.xyz);"
"}";
